#include <windows.h>
#include "hellowin.h"
#define ID_TIMER 1

//prototypes
long FAR PASCAL _export MainWndProc (HWND,WORD,WORD,LONG);
long FAR PASCAL _export HelloWndProc (HWND,UINT,UINT,LONG);
void CreateHelloWnd (HWND, HANDLE, char *);
void PaintHelloWnd (HWND, HDC);

//functions
int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance,
                    LPSTR lpszCmdLine, int nCmdShow)
	{
    static char szAppName[] = "Sample Hello Window";
    HWND hHelloWnd;
    MSG msg;
    HWND hWndMain;
    WNDCLASS wndclass;
	
    if (!hPrevInstance)
		{
		wndclass.style = CS_HREDRAW | CS_VREDRAW;
        wndclass.lpfnWndProc = MainWndProc;
        wndclass.cbClsExtra = 0;
        wndclass.cbWndExtra = 0;
        wndclass.hInstance = hInstance;
        wndclass.hCursor = LoadCursor(NULL, IDC_ARROW);
        wndclass.hIcon = NULL;
        wndclass.hbrBackground = COLOR_APPWORKSPACE +1;
        wndclass.lpszMenuName = "Main Window";
        wndclass.lpszClassName = szAppName;
		
        if (!RegisterClass (&wndclass))
			return FALSE;
		}
	
    if (!hPrevInstance)
 		{
        wndclass.style = CS_HREDRAW | CS_VREDRAW;
        wndclass.lpfnWndProc = HelloWndProc;
        wndclass.cbClsExtra	= 0;
        wndclass.cbWndExtra	= 0;
        wndclass.hInstance	= hInstance;
        wndclass.hIcon = NULL;
        wndclass.hCursor = LoadCursor (NULL, IDC_ARROW);
        wndclass.hbrBackground = GetStockObject (WHITE_BRUSH);
        wndclass.lpszMenuName = NULL;
        wndclass.lpszClassName = "HelloWindow";

        RegisterClass (&wndclass);
        }
	
    if (!(hWndMain = CreateWindow (szAppName,
                                   "Hello Window Example",
                                   WS_OVERLAPPEDWINDOW,
                                   CW_USEDEFAULT,0,
                                   CW_USEDEFAULT,0,
                                   NULL,NULL,hInstance,NULL)))
        return FALSE;

    ShowWindow (hWndMain, nCmdShow);
    UpdateWindow (hWndMain);
	
    CreateHelloWnd (hHelloWnd, hInstance, szAppName);

    while (GetMessage (&msg, NULL, 0, 0))
		{
        TranslateMessage (&msg);
        DispatchMessage (&msg);
        }
    return msg.wParam;
    }

long FAR PASCAL MainWndProc (HWND hWnd,WORD wMessage,WORD wParam,
                             LONG lParam)
	{
	switch(wMessage)
		{
        case WM_COMMAND:
			switch (wParam)
            	{
            	case IDM_EXIT:
                	SendMessage (hWnd, WM_DESTROY, NULL, NULL);
                	break;

                default:
                    return DefWindowProc (hWnd,
          		}
        		break;
        case WM_DESTROY:
			PostQuitMessage (0);
            break;

                default:
			return DefWindowProc(hWnd,wMessage,
                                             wParam,lParam);
    	}
    return 0L;
	}

void CreateHelloWnd (HWND hHelloWnd,HANDLE hInstance,
                     char *szAppName)
	{
	int iScreenWidth = (GetSystemMetrics (SM_CXSCREEN));
    int iScreenHeight = (GetSystemMetrics (SM_CYSCREEN));
    short xClient = 500;
    short yClient = 350;
    short xStart = (iScreenWidth - xClient) / 2;
    short yStart = (iScreenHeight - yClient) / 2;
	
	hHelloWnd =
        CreateWindow ("HelloWindow","HellowWindow", WS_POPUP |
                       WS_DLGFRAME | WS_EX_TOPMOST, xStart, yStart,
                       xClient,yClient,NULL,NULL,hInstance,NULL);

    SetWindowPos (hHelloWnd,-1,0,0,0,0,SWP_NOMOVE | SWP_NOSIZE);
		
	if (!SetTimer (hHelloWnd, ID_TIMER, 5000, NULL))
   		{
        MessageBox (hHelloWnd, "Clock timers exhausted!",
                    szAppName, MB_ICONEXCLAMATION | MB_OK);
        return;
        }
	
    ShowWindow (hHelloWnd, SW_SHOWNOACTIVATE);
    UpdateWindow (hHelloWnd);
    }

long FAR PASCAL _export HelloWndProc (HWND hHelloWnd, UINT message,
                                      UINT wParam, LONG lParam)
	{
    HDC hdc;
    PAINTSTRUCT ps;
	
	switch (message)
    	{
        case WM_PAINT:
        	hdc = BeginPaint (hHelloWnd, &ps);
            PaintHelloWnd (hHelloWnd, hdc);
            EndPaint (hHelloWnd, &ps);
            return 0;

        case WM_TIMER:
        	KillTimer (hHelloWnd, ID_TIMER);
            SendMessage (hHelloWnd, WM_CLOSE, NULL, NULL);
            return 0;

        case WM_CLOSE:
        	DestroyWindow (hHelloWnd);
            return 0;
        }
    return DefWindowProc (hHelloWnd, message, wParam, lParam);
    }

void PaintHelloWnd (HWND hHelloWnd, HDC hdc)
	{
    char cBuffer[250];
    RECT rect;
    short nLength = 0;

    nLength += wsprintf (cBuffer,"%s",
                         (LPSTR) "\r\n\r\n\r\n\r\n\r\n\r\n");
    nLength += wsprintf (cBuffer + nLength, "%s",
                         (LPSTR) "Example Hello Window.\r\n");
    nLength += wsprintf (cBuffer + nLength, "%s",
                         (LPSTR) "Timed to appear\r\n");
    nLength += wsprintf (cBuffer + nLength, "%s",
                         (LPSTR) "for 5 seconds!\r\n");
    GetClientRect (hHelloWnd, &rect);
    DrawText (hdc, cBuffer, -1, &rect, DT_CENTER | DT_NOCLIP);
    }
